Bug 1795936 - [RFE] createrepo_c should be able to handle modules information
Summary: [RFE] createrepo_c should be able to handle modules information
Keywords:
Status: POST
Alias: None
Product: Red Hat Enterprise Linux 8
Classification: Red Hat
Component: createrepo_c
Version: ---
Hardware: Unspecified
OS: Unspecified
medium
unspecified
Target Milestone: rc
: 8.0
Assignee: amatej
QA Contact: Eva Mrakova
URL:
Whiteboard:
Depends On:
Blocks: 1825061
TreeView+ depends on / blocked
 
Reported: 2020-01-29 09:41 UTC by Denis Volkov
Modified: 2020-07-29 12:26 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Knowledge Base (Solution) 4888921 None None None 2020-03-09 15:12:27 UTC

Description Denis Volkov 2020-01-29 09:41:29 UTC
Description of problem:
Currently createrepo does not handle modules information (modules.yaml) and as a result there are problems with repositories created from RHEL8 packages. Modules.yaml must be handled separately at the moment

Version-Release number of selected component (if applicable):
createrepo_c-0.11.0-3.el8.src.rpm

Steps to Reproduce:
1. Reposync RHEL8 repo:

dnf reposync --newest-only --repoid=rhel-8-for-x86_64-appstream-rpms --download-path=/var/www/html/rhel8 --downloadcomps --download-metadata 
createrepo -v /var/www/html/rhel8/rhel-8-for-x86_64-appstream-rpms/ -g comps.xml

2. Enable new repo

3. Try updating packages from the new repo

Actual results:
`dnf update` shows packages conflicts:

Fehler: 
 Problem 1: cannot install both perl-libs-4:5.24.4-404.module+el8.1.0+2926+ce7246ad.x86_64 and perl-libs-4:5.26.3-416.el8.x86_64
  - package perl-Digest-1.17-396.module+el8.1.0+2926+ce7246ad.noarch requires perl(:MODULE_COMPAT_5.24.4), but none of the providers can be installed
  - cannot install the best update candidate for package perl-libs-4:5.26.3-416.el8.x86_64
  - cannot install the best update candidate for package perl-Digest-1.17-395.el8.noarch

There is conflict between perl:5.24 and perl:5.26 stream

Additional info:
The problem arises because there is no information about modules in rpms. So createrepo does not see the information about modules and so is not able to pass this information to the system.

There is workaround: get modules info from the repocache and add it to the created repository:

    gunzip -c /var/cache/dnf/AppStream-..../repodata/...........-modules.yaml.gz > /tmp/AppStream-modules.yaml
    modifyrepo_c --mdtype=modules /tmp/AppStream-modules.yaml /var/www/html/rhel8/rhel-8-for-x86_64-appstream-rpms

Comment 3 Daniel Mach 2020-06-11 07:09:38 UTC
createrepo_c will scan for yaml files in addition to RPMs.
The patterns are:
  *.modulemd.yaml (recommended file name: N:S:V:C:A.modulemd.yaml)
  *.modulemd-defaults.yaml (recommended file name: N.modulemd-defaults.yaml)
  modules.yaml (recommended way of importing multiple documents at once)

The files can come from a directory scan or from -i, --pkglist.
Package list must support a mix of RPMs and yaml documents.
  
The patterns and supported modulemd documents will be extended in the future as needed. Most likely an extension to support EOL/Obsoletes will be needed:
https://fedoraproject.org/w/index.php?title=Changes/Module_Obsoletes_and_EOL

As the result, all found and supported yaml documents will be merged into [hash-]modules.yaml[.compression] in the repodata with <data type="modules">.

The files should be ordered prior creating modules.yaml to guarantee repeatability. See how createrepo_c orders RPMs.
If combination of individual yaml documents and modules.yaml is used, modules.yaml must go first and individual documents must override relevant parts of its original content.

createrepo_c --update will work work with the yaml documents the same way as createrepo_c in regular (non-update) mode, because the operation is relatively cheap and it's not necessary to compute any checksums as nedded for RPMs.


Note You need to log in before you can comment on or make changes to this bug.